﻿-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

local talenttree
local function Hedd_findclass()
	talenttree = GetPrimaryTalentTree() or 4
	if lib.classes[cfg.class] and lib.classes[cfg.class][talenttree] then
		cfg.classfound=true
		return lib.classes[cfg.class][talenttree]()
	end
	cfg.classfound=nil
	return false
end

lib.basicevents = function()
	function Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
		for index,name in pairs(cfg.spells) do
			if cfg.spells[index] and not cfg.spells[index].noupdate and lib.UpdateSpellCD(cfg.spells[index]) then cfg.Update=true end
		end
	end

	function Heddevents:ACTIONBAR_UPDATE_STATE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

	function Heddevents:ACTIONBAR_UPDATE_USABLE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

	function Heddevents:SPELL_UPDATE_USABLE()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
	end

--[[function Heddevents:UNIT_POWER(unit,...)
	if unit=="player" then
		cfg.power=UnitPower("player")
		print (cfg.power)
	end
end]]
	
	function Heddevents:UNIT_AURA(unitID)
		if cfg.watchunits[unitID] and UnitExists(unitID) then
			for index,name in pairs(cfg.auras) do
				if cfg.auras[index].unit==unitID and lib.UpdateAura(cfg.auras[index]) then
					cfg.Update=true
				end
			end
		end
		if lib.myaura then lib.myaura(unitID) end
	end

	function Heddevents:PLAYER_TARGET_CHANGED()
		Heddevents:UNIT_AURA("target")
	end
	
	function Heddevents:PLAYER_ENTERING_WORLD()
		Heddevents:ACTIONBAR_UPDATE_COOLDOWN()
		Heddevents:UNIT_AURA("player")
		Heddevents:UNIT_AURA("target")
		
		if lib.mypew then
			if lib.mypew() then
				cfg.Update=true
			end
		end
	end
	
	function Heddevents:PLAYER_REGEN_ENABLED()
		cfg.casting=nil
		cfg.lastspell=nil
	end
end

local p
lib.spellcastevents = function()
	cfg.casting=nil
	cfg.lastspell=nil
	cfg.iscasting=nil
--	cfg.ischanneling=nil
	local debugspells = nil
	
--[[	function Heddevents:UNIT_SPELLCAST_START(u,spellname)
		if u=="player" then
			cfg.iscasting=true
			cfg.casting=spellname
		end
	end

	function Heddevents:UNIT_SPELLCAST_CHANNEL_START(u,spellname)
		if u=="player" then
			cfg.ischanneling=true
			cfg.casting=spellname
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.ischanneling=nil
			cfg.casting=nil
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_INTERRUPTED(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_FAILED(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_STOP(u,spellname)
		Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
	end
	
	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.casting=nil
			cfg.ischanneling=nil
			cfg.lastspell=spellname
		end
	end]]
	
	function Heddevents:UNIT_SPELLCAST_START(u,spellname)
		if u=="player" then
			cfg.iscasting=true
			cfg.casting=spellname
			if debugspells then print(cfg.now.." UNIT_SPELLCAST_START "..spellname) end
		end
	end

	function Heddevents:UNIT_SPELLCAST_CHANNEL_START(u,spellname)
		if u=="player" then
			cfg.ischanneling=true
			cfg.casting=spellname
			if debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_START "..spellname) end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_STOP(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.ischanneling=nil
			cfg.casting=nil
			if debugspells then print(cfg.now.." UNIT_SPELLCAST_STOP "..spellname) end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_INTERRUPTED(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.ischanneling=nil
			cfg.casting=nil
			if debugspells then print(cfg.now.." UNIT_SPELLCAST_INTERRUPTED "..spellname) end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_CHANNEL_STOP(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.ischanneling=nil
			cfg.casting=nil
			if debugspells then print(cfg.now.." UNIT_SPELLCAST_CHANNEL_STOP "..spellname) end
		end
	end
	
	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.casting=nil
			cfg.ischanneling=nil
			cfg.lastspell=spellname
			if debugspells then print(cfg.now.." UNIT_SPELLCAST_SUCCEEDED "..spellname) end
		end
	end

--[[	function Heddevents:UNIT_SPELLCAST_FAILED(u,spellname)
		if u=="player" then
			cfg.iscasting=nil
			cfg.ischanneling=nil
			cfg.casting=nil
			print(cfg.now.." UNIT_SPELLCAST_FAILED "..spellname)
		end
	end]]
	
--[[	function Heddevents:UNIT_SPELLCAST_DELAYED(u,spellname)
		Heddevents:UNIT_SPELLCAST_START(u,spellname)
	end]]
--[[	function Heddevents:UNIT_SPELLCAST_CHANNEL_UPDATE(u,spellname)
		Heddevents:UNIT_SPELLCAST_START(u,spellname)
	end]]
--[[	function Heddevents:UNIT_SPELLCAST_SENT(u,spellname)
		if u=="player" then
			p = cfg.casting[spellname]
			cfg.casting[spellname]="casting"
			if cfg.casting[spellname]~=p then cfg.Update=true end
--			print(cfg.now.." sent "..spellname)
		end
	end]]
	
end

local lastUpdate=0
cfg.Update=nil
local ppower,phealth,mhealth

local function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

local function Hedd_onupdate(self, elapsed)
	lastUpdate = lastUpdate + elapsed
	cfg.now = GetTime()
	if cfg.Update or cfg.iscasting or cfg.ischanneling or lastUpdate > cfg.UpdateTime then

		ppower=cfg.power
		cfg.power=UnitPower("player")

		if cfg.power~=ppower then
			if lib.myonpowerupdate then
				lib.myonpowerupdate()
			end
		end
		
		phealth=cfg.health
		mhealth=UnitHealthMax("target")
		
		cfg.health=(mhealth==0) and 100 or round(UnitHealth("target")*100/mhealth,0)
		if cfg.health~=phealth then
			if lib.myonhealthupdate then
				lib.myonhealthupdate()
			end
		end
				
		if lib.myonupdate then
			lib.myonupdate()
		end
		
		if lib.rangecheck then
			lib.rangecheck()
		end
		
		lib.SetPriority()
	
		lastUpdate = 0
		cfg.Update=nil
		Heddframe.text:SetText(cfg.mode)
	end
end

local function Heddtal_onevent(self,event)
	for index,name in pairs(cfg.spells) do
		lib.HideFrame(cfg.spells[index].f)
	end
	Heddframe:Hide()
	
	lib.defaults()
	
	Heddframe:UnregisterAllEvents()
	Heddframe:SetScript("OnEvent",nil)
	Heddframe:SetScript("OnUpdate",nil)
	if Hedd_findclass() then
		lib.basicevents()
		if lib.classevents[cfg.class] then lib.classevents[cfg.class]() end
		if cfg.spellcaster then lib.spellcastevents() end
		
		cfg.case["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
			return true
		end
		
		cfg.numcase=0
		for key, value in pairs(cfg.plist) do
			cfg.numcase=cfg.numcase+1
		end
		cfg.numcase=cfg.numcase+1
		
		Heddframe:SetScript("OnEvent", function(self, cevent, ...)
			if not cfg.classfound then return end
			Heddevents[cevent](_,...)
		end)

		for k, v in pairs(Heddevents) do
			Heddframe:RegisterEvent(k)
		end
		
		Heddframe:SetScript("OnUpdate", Hedd_onupdate)
		
		if lib.mytal then
			lib.mytal()
		end
		
		Heddevents:PLAYER_ENTERING_WORLD()
		Heddframe:Show()
	end
	
end

cfg.notloaded=true
local function Heddframe_pew(self,...)
	if cfg.notloaded then 
		cfg.notloaded=nil
		Heddframe:UnregisterEvent("PLAYER_ENTERING_WORLD")
		Heddframe:RegisterForClicks("AnyUp")
		Heddframe:SetScript("OnClick", function (self, button, down)
		if lib.onclick then lib.onclick() end
		end);

		Heddtalents:SetScript("OnEvent",Heddtal_onevent)
		Heddtalents:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Heddtalents:RegisterEvent("CHARACTER_POINTS_CHANGED")
		Heddtalents:RegisterEvent("PLAYER_TALENT_UPDATE")
		Heddtal_onevent()
	end
end


Heddframe:SetScript("OnEvent",Heddframe_pew)
Heddframe:RegisterEvent("PLAYER_ENTERING_WORLD")